`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/30/2020 03:10:47 PM
// Design Name: 
// Module Name: Lab5_3
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab5_3(
    f_crystal,
    mode_in,
    state_in,
    state_LED,
    mode_LED,
    ssd_ctl,
    D_ssd
    );
    
    input f_crystal;
    input mode_in, state_in;
    output state_LED, mode_LED;
    output [3:0]ssd_ctl;
    output [7:0]D_ssd;
    wire clk_1;
    wire clk_100;
    wire rst;
    wire [1:0]ssd_clk;
    wire state_deb_out, state_onePulse_out, reset_out;
    wire mode_deb_out, mode_onePulse_out;
    wire count_enable;
    wire [3:0]out30_0, out30_1, out30_2;
    wire [3:0]out60_0, out60_1, out60_2;
    wire [3:0]ssd_in;
    wire point;
    
    reg [3:0]disp_0, disp_1, disp_2;
    reg global_decrease;
    
    
     always @*
        if((disp_0 == 0 && disp_1 == 0 && disp_2 == 0) || count_enable == 0)
             global_decrease = 0;
        else
             global_decrease = 1;
    
    frq_div U0(
    .f_out(clk_1), // divided clock output
    .clk_100(clk_100),
    .ssd_clk(ssd_clk),
    .f_crystal(f_crystal), // global clock input
    .rst(rst) // active low reset
    );
    
   debounce U1(
      .clk(clk_100), // clock control
      .rst(rst), // reset
      .pb_in(state_in), //push button input
      .pb_debounced(state_deb_out) // debounced push button output
    );
    
    rst_count U2(
        .in(state_deb_out),
        .out(reset_out),
        .clk(f_crystal),
        .rst(rst)
    );
    
    one_pulse U3(
      .clk(clk_1),  // clock input
      .rst(rst), //active low reset
      .in_trig(reset_out), // input trigger
      .out_pulse(state_onePulse_out) // output one pulse 
    );
    
    state_FSM U6(
    .count_enable(count_enable), // if counter is enabled
    .in(state_onePulse_out), //input control
    .clk(clk_1), // global clock signal
    .rst(rst), // high active reset
    .state(state_LED)
    );
    
     mode_debounce U4(
     .clk(clk_100), // clock control
     .rst(rst), // reset
     .pb_in(mode_in), //push button input
     .pb_debounced(mode_deb_out) // debounced push button output
   );
   
    mode_one_pulse U5(
        .clk(clk_1),  // clock input
        .rst(rst), //active low reset
        .in_trig(mode_deb_out), // input trigger
        .out_pulse(mode_onePulse_out) // output one pulse 
    );
    
    mode_FSM U7(
    .in(mode_onePulse_out), //input control
    .clk(clk_1), // global clock signal
    //.rst(rst), // high active reset
    .state(mode_LED)
    );
    
    Timer60 U8(
        .out0(out60_0),
        .out1(out60_1),
        .out2(out60_2),
        .decrease(global_decrease),
        .clk(clk_1),
        .rst(rst)
    );
    
    Timer30 U9(
        .out0(out30_0),
        .out1(out30_1),
        .out2(out30_2),
        .decrease(global_decrease),
        .clk(clk_1),
        .rst(rst)
        );
    always @*
        if(mode_LED)
            begin
                disp_0 = out60_0;
                disp_1 = out60_1;
                disp_2 = out60_2;
            end
        else
            begin
                disp_0 = out30_0;
                disp_1 = out30_1;
                disp_2 = out30_2;
            end
            
     scan_ctl U10(
      .ssd_ctl(ssd_ctl), // ssd display control signal 
      .ssd_in0(disp_0), // output to ssd display
      .ssd_in1(disp_1),
      .ssd_in2(disp_2),
      .ssd_in(ssd_in),
      .ssd_ctl_clk(ssd_clk),
      .point(point),  
      .rst(rst)   // reset
    );
    
    Display_7_segment U11(.D_ssd(D_ssd), .i(ssd_in), .point(point));

        
endmodule
