`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2018/03/29 20:12:21
// Design Name: 
// Module Name: FSM
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define STAT_PAUSE 1'b0
`define STAT_COUNT 1'b1
`define ENABLED 1'b1
`define DISABLED 1'b0
`define mode0 1'b0
`define mode1 1'b1

module mode_FSM(
in, //input control
clk, // global clock signal
rst, // high active reset
state
);



// inputs
input clk; // global clock signal
input rst; // high active reset
input in; //input control
output reg state;
reg next_state; // next state of FSM

// FSM state decision
always @*
  case (state)
    `mode0:
    if (in)
        begin
        next_state = `mode1;
        end
    else
        begin
        next_state = `mode0;
        end
    `mode1:
    if (in)
        begin
        next_state = `mode0;
        end
    else
        begin
        next_state = `mode1;
        end
  default:
      begin
      next_state = `mode0;
      end
    endcase
    
    // FSM state transition
always @(posedge clk or posedge rst)
    if (rst)
        state <= `mode0;
    else
        state <= next_state;
    
    endmodule
